<?php

/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */

namespace Helper;

use Base\BaseHelper;
use Model\TransactionModel;

class TransactionHelper extends BaseHelper
{
    // public $alias=[:ALIAS_PROPERTY:];
    //public $relation=[];
    public $model = "\Model\TransactionModel";

    public function __construct()
    {
        parent::__construct();
    }

    public function paging($input)
    {
        $model = new TransactionModel();
        $model->paginating($input);
        $model = $model->getPaginate();
        return $model;
    }

    public function show($id)
    {
        $model = new TransactionModel();
        $model = $model->findById($id);
        return $model;
    }

    public function store($input)
    {
        $this->beforeInsert($input["Transaction"]);
        $model = new TransactionModel($input["Transaction"]);
        if (!$model->save()) {
            throw new \Exception();
        }
        return $model;
    }

    public function delete($id)
    {
        $this->beforeDelete($id);
        $model = TransactionModel::find($id);
        if (!$model->delete()) {
            throw new \Exception();
        }
        return $model;
    }

    public function update($id, $input)
    {
        $this->beforeUpdate($id, $input);
        $model = TransactionModel::find($id);
        $model->setProperty($input["Transaction"]);
        if (!$model->update()) {
            throw new \Exception();
        }
        return $model;
    }

    public function storeTransaction($input)
    {
        $transaction = new TransactionModel($input["Transaction"]);
        if (!$transaction->save()) {
            throw new \Exception();
        }
        foreach ($input["Transactiondebit"] as $keyTransactiondebit) {
            $transactiondebit = new \Helper\TransactiondebitHelper();
            $transactiondebit = $transactiondebit->storeFromTransaction($transaction->id, $keyTransactiondebit);
        }
        return $transaction;
    }


}